# Installing Document Areas

## Creating an empty document area while deploying an Instance

This is the simplest sample, just the core services with an empty document area:

```
helm install \
  --values samples/application/empty.yaml \
  --values samples/environment/demo.yaml \
  empty nplus/nplus-instance
```

The empty Document Area is created with 

```yaml
components:
  application: true
  prepper: true
  
application:
  docAreas:
    - id: "Sample"
  run:
    - "/pool/downloads/sample.sh"

prepper:
  download:
    - "https://git.nplus.cloud/public/nplus/raw/branch/master/assets/sample.tar.gz"
```

This turns on the *prepper* component, used to download a sample tarball from git. It will also extract the tarball into the `downloads` folder that is created on the *pool* automatically.

Then, after the Application Layer is running, a document area `Sample` is created. The content of the sample script will be executed.

If you use **argoCD** as deployment tool, you would go with

```
helm install \
  --values samples/application/empty.yaml \
  --values samples/environment/demo.yaml \
  empty-argo nplus/nplus-instance-argo
```



## Deploying the *SBS* Apps to a new document area

In the SBS scenario, some Apps are installed into the document area:

```bash
helm install \
  --values samples/applications/sbs.yaml \
  --values samples/environment/demo.yaml \
  sbs nplus/nplus-instance
```

The values look like this:

```yaml
components:
  application: true
application:
  nameOverride: SBS
  docAreas:
    - id: "SBS"
      name: "DocArea with SBS"
      description: "This is a sample DocArea with the SBS Apps installed"
      apps:
      - "/pool/nstore/bl-app-9.0.1202.zip"
      - "/pool/nstore/gdpr-app-9.0.1302.zip"
      ...
      - "/pool/nstore/ts-app-9.0.1302.zip"
      - "/pool/nstore/ocr-base-9.0.1302.zip"

```

This will create a document area `SBS` and install the SBS Apps into it.


# Accounting in nstl

To collect Accounting Data in *nscale Server Storage Layer*, you can enable the nstl accouting feature by setting `accounting: true`.
This will create the accounting csv files in *ptemp* under `<instance>/<component>/accounting`.
Additionally, you can enable a log forwarder printing it to stdout.

```
nstl:
  accounting: true
  logForwarder:
    - name: Accounting
      path: "/opt/ceyoniq/nscale-server/storage-layer/accounting/*.csv"
```
